// pdb.cpp : Defines the entry point for the console application.
//
#include <stdio.h>
#include <stdlib.h>

bool GenGroC10(int nAllX, int nAllY, int nAllZ, 
			   int nAtomFrom, int nMoleFrom,
			double dShiftX, double dShiftY, double dShiftZ)
{
	FILE* f = fopen("conf.gro", "a");
	if(!f)
		return false;
	int nAtom = 0;
	int nMole = 0;
	double dx = 1.551894;
	double dy = 0.466448;
	double dz = 0.466448;
	for(int i=0; i<nAllX; i++)
	{
		for(int j=0; j<nAllY; j++)
		{
			for(int k=0; k<nAllZ; k++)
			{
				nMole++;
				for(int m=0; m<10; m++)
				{
					nAtom++;
					const double xyz[10][3] = 
					{
						{	0.369, 	0.079, 	0.030} ,
						{	0.494, 	0.000, 	0.063 } ,
						{	0.613, 	0.087, 	0.024 } ,
						{	0.742, 	0.014, 	0.056 } ,
						{	0.859, 	0.102, 	0.016 } ,
						{	0.989, 	0.030, 	0.048 } ,
						{	1.106, 	0.119, 	0.007 } ,
						{	1.232, 	0.043, 	0.040 } ,
						{	1.355, 	0.122, 	0.000 },
						{	1.469, 	0.029, 	0.033 } 
					};
					double x = xyz[m][0] + dx*i + dShiftX;
					double y = xyz[m][1] + dy*j + dShiftY;
					double z = xyz[m][2] + dz*k + dShiftZ;
					const char* lpsz2 = "% 5dC10    C%02X% 5d%8.3f%8.3f%8.3f\n";
					fprintf(f, lpsz2, nMole+nMoleFrom, m+1, nAtom+nAtomFrom, x, y, z);
				}
			}
		}
	}
	//fprintf(f,"%10.5f%10.5f%10.5f\n", 3, 4dx, 4dx);
	fclose(f);
	return true;
}
bool GenGroWater(int nAllX, int nAllY, int nAllZ, 
				 int nAtomFrom, int nMoleFrom, 
				 double dShiftX, double dShiftY, double dShiftZ)
{
	FILE* f = fopen("conf.gro", "a");
	if(!f)
		return false;
	int nMole = 0;
	int nAtom = 0;
	double dx = 0.310378768;
	for(int i=0; i<nAllX; i++)
	{
		for(int j=0; j<nAllY; j++)
		{
			for(int k=0; k<nAllZ; k++)
			{
				nMole++;
				const double water[3][3] = 
				{
					{ .230  ,  .039, .092},
					{ .137  ,  .037, .129},
					{ .231  ,  0,   0}
				};
				double fr = (rand() % 1000) / 10000.0 - .05;
				double x = water[0][0] + dx*i+dShiftX + fr;
				double y = water[0][1] + dx*j+dShiftY + fr;
				double z = water[0][2] + dx*k+dShiftZ + fr;
				fprintf(f, "% 5dHOH     OW% 5d%8.3f%8.3f%8.3f\n", nMole+nMoleFrom,nMole*3-2+nAtomFrom, x, y, z);
				x = water[1][0] + dx*i+dShiftX + fr;
				y = water[1][1] + dx*j+dShiftY + fr;
				z = water[1][2] + dx*k+dShiftZ + fr;
				fprintf(f, "% 5dHOH    HW1% 5d%8.3f%8.3f%8.3f\n", nMole+nMoleFrom,nMole*3-1+nAtomFrom, x, y, z);
				x = water[2][0] + dx*i+dShiftX + fr;
				y = water[2][1] + dx*j+dShiftY + fr;
				z = water[2][2] + dx*k+dShiftZ + fr;
				fprintf(f, "% 5dHOH    HW2% 5d%8.3f%8.3f%8.3f\n", nMole+nMoleFrom,nMole*3-0+nAtomFrom, x, y, z);
			}
		}
	}
	fclose(f);
	return true;
}
int main(int argc, char* argv[])
{
	int nRetCode = 0;

	FILE* f = fopen("conf.gro", "w");
	fprintf(f,"oil and water\n 6500\n");
	fclose(f);
	
	GenGroC10(	2,	10,	5,	0,		0,		0, 0, 0);
	GenGroC10(	2,	10,	5,	1000,	100,	0, 0, 3.10379 + 2.33224 );
	GenGroWater(10, 15, 10, 2000,	200,	0, 0, 2.33224 );

	f = fopen("conf.gro", "a");
	double dx = 1.551894;
	double dy = 0.466448;
	double dz1 = 0.466448;
	double dz2 = 0.310378768;
	
	fprintf(f, "%10.5f%10.5f%10.5f\n", dx*2, dy*10, dz1*10 + dz2*10);
	fclose(f);

	return nRetCode;
}
